Index: trunk/src/VBox/VMM/VMMR0/HWVMXR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/HWVMXR0.cpp	(revision 44088)
+++ trunk/src/VBox/VMM/VMMR0/HWVMXR0.cpp	(revision 44089)
@@ -103,5 +103,5 @@
 
         VMXReadVmcs(VMX_VMCS32_RO_VM_INSTR_ERROR, &instrError);
-        pVCpu->hm.s.vmx.lasterror.ulInstrError = instrError;
+        pVCpu->hm.s.vmx.lasterror.u32InstrError = instrError;
     }
     pVM->hm.s.lLastError = rc;
@@ -4912,7 +4912,7 @@
         /* Try to extract more information about what might have gone wrong here. */
         VMXGetActivateVMCS(&pVCpu->hm.s.vmx.lasterror.u64VMCSPhys);
-        pVCpu->hm.s.vmx.lasterror.ulVMCSRevision = *(uint32_t *)pVCpu->hm.s.vmx.pvVMCS;
-        pVCpu->hm.s.vmx.lasterror.idEnteredCpu   = pVCpu->hm.s.idEnteredCpu;
-        pVCpu->hm.s.vmx.lasterror.idCurrentCpu   = RTMpCpuId();
+        pVCpu->hm.s.vmx.lasterror.u32VMCSRevision = *(uint32_t *)pVCpu->hm.s.vmx.pvVMCS;
+        pVCpu->hm.s.vmx.lasterror.idEnteredCpu    = pVCpu->hm.s.idEnteredCpu;
+        pVCpu->hm.s.vmx.lasterror.idCurrentCpu    = RTMpCpuId();
     }
 
@@ -5175,6 +5175,6 @@
                 Log(("Current stack %08x\n", &rc2));
 
-                pVCpu->hm.s.vmx.lasterror.ulInstrError = instrError;
-                pVCpu->hm.s.vmx.lasterror.ulExitReason = exitReason;
+                pVCpu->hm.s.vmx.lasterror.u32InstrError = instrError;
+                pVCpu->hm.s.vmx.lasterror.u32ExitReason = exitReason;
 
 #ifdef VBOX_STRICT
Index: trunk/src/VBox/VMM/VMMR3/HM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 44088)
+++ trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 44089)
@@ -1328,5 +1328,5 @@
                 LogRel(("HM: VMX setup failed with rc=%Rrc!\n", rc));
                 for (VMCPUID i = 0; i < pVM->cCpus; i++)
-                    LogRel(("HM: CPU[%ld] Last instruction error %x\n", i, pVM->aCpus[0].hm.s.vmx.lasterror.ulInstrError));
+                    LogRel(("HM: CPU[%ld] Last instruction error %x\n", i, pVM->aCpus[0].hm.s.vmx.lasterror.u32InstrError));
                 pVM->fHMEnabled = false;
             }
@@ -2704,5 +2704,5 @@
             case VERR_VMX_INVALID_VMCS_PTR:
                 LogRel(("VERR_VMX_INVALID_VMCS_PTR: CPU%d Current pointer %RGp vs %RGp\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.u64VMCSPhys, pVM->aCpus[i].hm.s.vmx.HCPhysVMCS));
-                LogRel(("VERR_VMX_INVALID_VMCS_PTR: CPU%d Current VMCS version %x\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.ulVMCSRevision));
+                LogRel(("VERR_VMX_INVALID_VMCS_PTR: CPU%d Current VMCS version %x\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.u32VMCSRevision));
                 LogRel(("VERR_VMX_INVALID_VMCS_PTR: CPU%d Entered Cpu %d\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.idEnteredCpu));
                 LogRel(("VERR_VMX_INVALID_VMCS_PTR: CPU%d Current Cpu %d\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.idCurrentCpu));
@@ -2710,7 +2710,7 @@
 
             case VERR_VMX_UNABLE_TO_START_VM:
-                LogRel(("VERR_VMX_UNABLE_TO_START_VM: CPU%d instruction error %x\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.ulInstrError));
-                LogRel(("VERR_VMX_UNABLE_TO_START_VM: CPU%d exit reason       %x\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.ulExitReason));
-                if (pVM->aCpus[i].hm.s.vmx.lasterror.ulInstrError == VMX_ERROR_VMENTRY_INVALID_CONTROL_FIELDS)
+                LogRel(("VERR_VMX_UNABLE_TO_START_VM: CPU%d instruction error %x\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.u32InstrError));
+                LogRel(("VERR_VMX_UNABLE_TO_START_VM: CPU%d exit reason       %x\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.u32ExitReason));
+                if (pVM->aCpus[i].hm.s.vmx.lasterror.u32InstrError == VMX_ERROR_VMENTRY_INVALID_CONTROL_FIELDS)
                 {
                     LogRel(("VERR_VMX_UNABLE_TO_START_VM: Cpu%d MSRBitmapPhys %RHp\n", i, pVM->aCpus[i].hm.s.vmx.HCPhysMsrBitmap));
@@ -2727,6 +2727,6 @@
 
             case VERR_VMX_UNABLE_TO_RESUME_VM:
-                LogRel(("VERR_VMX_UNABLE_TO_RESUME_VM: CPU%d instruction error %x\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.ulInstrError));
-                LogRel(("VERR_VMX_UNABLE_TO_RESUME_VM: CPU%d exit reason       %x\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.ulExitReason));
+                LogRel(("VERR_VMX_UNABLE_TO_RESUME_VM: CPU%d instruction error %x\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.u32InstrError));
+                LogRel(("VERR_VMX_UNABLE_TO_RESUME_VM: CPU%d exit reason       %x\n", i, pVM->aCpus[i].hm.s.vmx.lasterror.u32ExitReason));
                 break;
 
Index: trunk/src/VBox/VMM/include/HMInternal.h
===================================================================
--- trunk/src/VBox/VMM/include/HMInternal.h	(revision 44088)
+++ trunk/src/VBox/VMM/include/HMInternal.h	(revision 44089)
@@ -611,7 +611,7 @@
         {
             uint64_t                u64VMCSPhys;
-            uint32_t                ulVMCSRevision;
-            uint32_t                ulInstrError;
-            uint32_t                ulExitReason;
+            uint32_t                u32VMCSRevision;
+            uint32_t                u32InstrError;
+            uint32_t                u32ExitReason;
             RTCPUID                 idEnteredCpu;
             RTCPUID                 idCurrentCpu;